#include <iostream>
using namespace std;


//        NodeTree
enum RedBlack {Red, Black};
struct TreeNodeQData
{
    long CoefNumber;
    long CreatedFrom;
};
struct TreeNodeData
{
	long Value;
	int QUk;
	RedBlack Color;					//   
	TreeNodeData* PParent;			//   
	TreeNodeData* PLeft;			//    
	TreeNodeData* PRight;			//    
};

TreeNodeData* PRoot;				//     
TreeNodeData* PNil;					//    "Nil"   ,
									//        
									// ,      NULL.   
									// ,     
							
    long a[1001];
    long x[200001];
    TreeNodeQData TreeNodeQ[1001][1001];
    int TreeNodeQCount[1001];
    int FreeQUk[1001];
    int FreeQUkCount;
TreeNodeData* SearchInTree(TreeNodeData* Pv, long v)
{
	TreeNodeData* Pw;
	if (PRoot == PNil)
	   Pw = PNil;
	else
	  if (Pv->Value == v)
		Pw = Pv;
	  else
		if (v < Pv->Value)
			if (Pv->PLeft != PNil)
				Pw = SearchInTree(Pv->PLeft, v);
			else
				Pw =PNil;
		else
			if (Pv->PRight != PNil)
				Pw = SearchInTree(Pv->PRight, v);
			else
				Pw = PNil;
		  
	return Pw;
}

//******************************************************************************
void LeftRotate(TreeNodeData* Pv)
{
//  ,  ,    Pv,    
	TreeNodeData* Pw;
	Pw = Pv->PRight;
	Pv->PRight = Pw->PLeft;
	if (Pw->PLeft != PNil)
		Pw->PLeft->PParent = Pv;
	Pw->PParent = Pv->PParent;
	if (Pv->PParent == PNil)
		PRoot = Pw;
	else
		if (Pv->PParent->PLeft == Pv)
			Pv->PParent->PLeft = Pw;
		else
			Pv->PParent->PRight = Pw;
	Pw->PLeft = Pv;
	Pv->PParent = Pw;
}

//******************************************************************************
void RightRotate(TreeNodeData* Pv)
{
//  ,  ,    Pv,    
	TreeNodeData* Pw;
	Pw = Pv->PLeft;
	Pv->PLeft = Pw->PRight;
	if (Pw->PRight != PNil)
		Pw->PRight->PParent = Pv;
	Pw->PParent = Pv->PParent;
	if (Pv->PParent == PNil)
		PRoot = Pw;
	else
		if (Pv->PParent->PLeft == Pv)
			Pv->PParent->PLeft = Pw;
		else
		  Pv->PParent->PRight = Pw;
	Pw->PRight = Pv;
	Pv->PParent = Pw;
}

//***************************************************************************************
TreeNodeData* InsertInTree(TreeNodeData *Pv, long v, long cn, long cf)
{
	TreeNodeData* NewNode;
	int i,j;
	if (v == Pv->Value)
	{
       i = Pv->QUk;
       TreeNodeQCount[i]++;
       j=TreeNodeQCount[i];
       TreeNodeQ[i][j].CoefNumber = cn;
       TreeNodeQ[i][j].CreatedFrom = cf;
       NewNode = PNil;
       return NewNode;  
    }
	if (v < Pv->Value)
		if (Pv->PLeft != PNil)
			NewNode = InsertInTree(Pv->PLeft, v, cn, cf);
		else	//           Pv
		{
			NewNode = new TreeNodeData;
			NewNode->Value = v;
			i = FreeQUk[FreeQUkCount];
			NewNode->QUk = i;
			FreeQUkCount--;
			TreeNodeQCount[i] = 1;
			TreeNodeQ[i][1].CoefNumber = cn;
            TreeNodeQ[i][1].CreatedFrom = cf;
			NewNode->Color = Red;
			NewNode->PParent = Pv;
			NewNode->PLeft = PNil;
			NewNode->PRight = PNil;
			Pv->PLeft = NewNode;
		}
	else
		if (Pv->PRight != PNil)
			NewNode = InsertInTree(Pv->PRight, v, cn, cf);
		else  //           v
		{
			NewNode = new TreeNodeData;
			NewNode->Value = v;
			i = FreeQUk[FreeQUkCount];
			NewNode->QUk = i;
			FreeQUkCount--;
			TreeNodeQCount[i] = 1;
			TreeNodeQ[i][1].CoefNumber = cn;
            TreeNodeQ[i][1].CreatedFrom = cf;
			NewNode->Color = Red;
			NewNode->PParent = Pv;
			NewNode->PLeft = PNil;
			NewNode->PRight = PNil;
			Pv->PRight = NewNode;
		}
	return NewNode;	
}

//***************************************************************************************
void RedBlackTree(TreeNodeData* Pv)
{   TreeNodeData* Pw;
	while ((Pv != PRoot) && (Pv->PParent->Color == Red))
	{
		if (Pv->PParent == Pv->PParent->PParent->PLeft)
		{
			Pw = Pv->PParent->PParent->PRight;
			if (Pw->Color == Red)
			{
				Pv->PParent->Color = Black;
				Pw->Color = Black;
				Pv->PParent->PParent->Color = Red;
				Pv = Pv->PParent->PParent;
			}
			else
			{
				if (Pv == Pv->PParent->PRight)
				{
					Pv = Pv->PParent;
					LeftRotate(Pv);
				}
				Pv->PParent->Color = Black;
				Pv->PParent->PParent->Color = Red;
				RightRotate(Pv->PParent->PParent);
			}
		}
		else
		{
			Pw = Pv->PParent->PParent->PLeft;
			if (Pw->Color == Red)
			{
				Pv->PParent->Color = Black;
				Pw->Color = Black;
				Pv->PParent->PParent->Color = Red;
				Pv = Pv->PParent->PParent;
			}
			else
			{
				if (Pv == Pv->PParent->PLeft)
				{
					Pv = Pv->PParent;
					RightRotate(Pv);
				}
				Pv->PParent->Color = Black;
				Pv->PParent->PParent->Color = Red;
				LeftRotate(Pv->PParent->PParent);
			}
		}
	}
	PRoot->Color = Black;
}

//***************************************************************************************
void AddToTree(long v, long cn, long cf)
{   
    int i;
    TreeNodeData* NewNode;
	if (PRoot == PNil)
	{
		PRoot = new TreeNodeData;
		PRoot->Value = v;
		i = FreeQUk[FreeQUkCount];
		PRoot->QUk = i;
		FreeQUkCount--;
		TreeNodeQCount[i] = 1;
		TreeNodeQ[i][1].CoefNumber = cn;
        TreeNodeQ[i][1].CreatedFrom = cf;
		PRoot->Color = Black;
		PRoot->PParent = PNil;
		PRoot->PLeft = PNil;
		PRoot->PRight = PNil;
	}
	else
	{
		TreeNodeData* NewNode;
		NewNode = InsertInTree(PRoot, v, cn, cf);
		if (NewNode != PNil)
          RedBlackTree(NewNode);
	}
}
//***************************************************************************************
void RedBlackDeleteFixup (TreeNodeData* Pv)
{
	TreeNodeData* Pw;
	while ((Pv != PRoot) && (Pv->Color == Black))
	{
		if (Pv == Pv->PParent->PLeft)
		{
			Pw = Pv->PParent->PRight;
			if (Pw->Color == Red)
			{
				Pw->Color = Black;
				Pv->PParent->Color = Red;
				LeftRotate(Pv->PParent);
				Pw = Pv->PParent->PRight;
			}
			if ((Pw->PLeft->Color == Black) && (Pw->PRight->Color == Black))
			{
				Pw->Color = Red;
				Pv = Pv->PParent;
			}
			else
			{
				if (Pw->PRight->Color == Black)
				{
					Pw->PLeft->Color = Black;
					Pw->Color = Red;
					RightRotate(Pw);
					Pw = Pv->PParent->PRight;
				}
				Pw->Color = Pv->PParent->Color;
				Pv->PParent->Color = Black;
				Pw->PRight->Color = Black;
				LeftRotate(Pv->PParent);
				Pv = PRoot;
			}
		}
		else
		{
			Pw = Pv->PParent->PLeft;
			if (Pw->Color == Red)
			{
				Pw->Color = Black;
				Pv->PParent->Color = Red;
				RightRotate(Pv->PParent);
				Pw = Pv->PParent->PLeft;
			}
			if ((Pw->PRight->Color == Black) && (Pw->PLeft->Color == Black))
			{
				Pw->Color = Red;
				Pv = Pv->PParent;
			}
			else
			{
				if (Pw->PLeft->Color == Black)
				{
					Pw->PRight->Color = Black;
					Pw->Color = Red;
					LeftRotate(Pw);
					Pw = Pv->PParent->PLeft;
				}
				Pw->Color = Pv->PParent->Color;
				Pv->PParent->Color = Black;
				Pw->PLeft->Color = Black;
				RightRotate(Pv->PParent);
				Pv = PRoot;
			}
		}
	}
	Pv->Color = Black;
}

//***************************************************************************************
void RedBlackDelete (TreeNodeData* Pv)
{
    int i; 
	TreeNodeData* Py;
	TreeNodeData* Px;
	if ((Pv->PLeft == PNil) || (Pv->PRight == PNil))
		Py = Pv;								//      
	else
	{
		//    -  Py    ,   
		//   Value
		Py = Pv->PRight;
		while (Py->PLeft != PNil)
		{
			Py = Py->PLeft;
		}
	}
	if (Py->PLeft != PNil)
		Px = Py->PLeft;
	else
		Px = Py->PRight;
	Px->PParent = Py->PParent;
	if (Py == PRoot)
		PRoot = Px;
	else
		if (Py == Py->PParent->PLeft)
			Py->PParent->PLeft = Px;
		else
			Py->PParent->PRight = Px;
	if (Pv != Py)
	{
		Pv->Value = Py->Value;
		Pv->QUk = Py->QUk;
		
	}
	if (Py->Color == Black)
		RedBlackDeleteFixup(Px);
		
	delete Py;
}

TreeNodeData* FindMin()
{
    TreeNodeData* Pv;
    Pv = PRoot;
    while (Pv->PLeft != PNil)
      Pv = Pv->PLeft;
    return Pv;  
}
//******************************************************************************


int main ()
{
    long n, k;
    long m=0;
    long i, j, v, p, q;
    
    TreeNodeData* Pw;
    PNil = new TreeNodeData;
	PNil->Value = 0;
	PNil->QUk = 0;	
	PNil->Color = Black;
	PNil->PParent = 0;
	PNil->PLeft = 0;
	PNil->PRight = 0;
	PRoot = PNil;
	x[0] = 0;
	
	cin >>n>>k;
	
	for (i=1;i<=k;i++)
	  {
        FreeQUk[i]=i;
        TreeNodeQCount[i] = 0;
      }
    FreeQUkCount = k;
        
	for (i=1;i<=k;i++)
	{
	  cin >> a[i];
	  AddToTree(a[i], i, 0);
    } 
    
    while (m < n)
    {
      Pw = FindMin();
      m++;
      x[m] = Pw->Value;
      j = Pw->QUk;
      RedBlackDelete(Pw);
      for (i=1;i<=TreeNodeQCount[j];i++)
      {
          q = TreeNodeQ[j][i].CoefNumber;
          p = TreeNodeQ[j][i].CreatedFrom+1;
          v = x[p]+a[q];
          AddToTree(v,q,p);
      }
      TreeNodeQCount[j] = 0;
      FreeQUkCount++;
      FreeQUk[FreeQUkCount] = j;
           
    }
           
	cout << x[m] << endl;
	
	//for (i=1;i<=m;i++)
	  //cout << x[i] << endl;
	
	// system ("pause");
    return 0;
}
